--AH:ScriptId=e21ea303-cba0-43bc-b1cf-3790da48d4e9

CREATE TABLE [Prompts]
(
	[Prompt_Id] INT NOT NULL IDENTITY(1,1),
	[Title_Text] VARCHAR(50) NOT NULL,
    [Prompt_Text] VARCHAR(MAX) NOT NULL

	CONSTRAINT [PK__Prompts]
		PRIMARY KEY ([Prompt_Id]),

	CONSTRAINT [UQ__Prompts]
		UNIQUE ([Title_Text])
)

GO

INSERT INTO [Prompts] ([Title_Text], [Prompt_Text])
VALUES ('Default', 'Write an analysis of the following vulnerability.  This analysis must include a description of what the library is/does, what is vulnerabable, how it may affect the application, and how to mitigate it.  Do not include the CVE identifier, resources, and references in the output because these are shown outside this analysis. Do not directly include the vulnerability metrics (like CVSS and CVSS_Score) or CWE weaknesses (CWE-ID) in the output, but use their information explain the analysis.  Format the output in markdown using CommonMark syntax and include section headers. Do not include any H1 headers.

{VULNERABILITY_DETAILS}')

INSERT INTO [Prompts] ([Title_Text], [Prompt_Text])
VALUES ('Use ISL Data', 'Write an analysis of the following vulnerability.  This analysis must include a description of what the library is/does, what is vulnerabable, how it may affect the application, and how to mitigate it.  Do not include the CVE identifier, resources, and references in the output because these are shown outside this analysis. Do not directly include the vulnerability metrics (like CVSS and CVSS_Score) or CWE weaknesses (CWE-ID) in the output, but use their information explain the analysis.  Format the output in markdown using CommonMark syntax and include section headers. Do not include any H1 headers.

{ISL_DETAILS}')

INSERT INTO [Prompts] ([Title_Text], [Prompt_Text])
VALUES ('Use both NVD and ISL', 'Write an analysis of the following vulnerability. This analysis must include a description of what the library is/does, what is vulnerabable, how it may affect the application, and how to mitigate it.  Do not include the CVE identifier, resources, and references in the output because these are shown outside this analysis. Do not directly include the vulnerability metrics (like CVSS and CVSS_Score) or CWE weaknesses (CWE-ID) in the output, but use their information explain the analysis.  Format the output in markdown using CommonMark syntax and include section headers. Do not include any H1 headers.

{ISL_DETAILS}

Here is the information national vulnerability database:

{VULNERABILITY_DETAILS}')
