--AH:ScriptId=A4E9EA06-A9A6-4E72-848C-C7E7B1E8C6F8

CREATE TABLE [Executions]
(
	[Execution_Id] INT IDENTITY(1, 1) NOT NULL,
	[Start_Date] DATETIME NOT NULL,
	[End_Date] DATETIME NULL,
	[ExecutionStatus_Code] CHAR(1) NOT NULL,
	[ExecutionRunState_Code] CHAR(1) NOT NULL,
	[ExecutionName_Text] VARCHAR(200) NOT NULL,

	CONSTRAINT [PK__Executions]
		PRIMARY KEY ([Execution_Id]),

	CONSTRAINT [CK__Executions__ExecutionStatus_Code]
		CHECK ([ExecutionStatus_Code] IN ('E', 'W', 'S')),

	CONSTRAINT [CK__Executions__ExecutionRunState_Code]
		CHECK ([ExecutionRunState_Code] IN ('C', 'X', 'P'))
)

CREATE TABLE [ScopedExecutionLogs]
(
	[Execution_Id] INT NOT NULL,
	[Scope_Sequence] INT NOT NULL,
	[Parent_Scope_Sequence] INT NULL,
	[Scope_Name] VARCHAR(MAX) NOT NULL,
	[Start_Date] DATETIME NOT NULL,
	[End_Date] DATETIME NULL,
	[HighestLogEntry_Level] INT NULL,

	CONSTRAINT [PK__ScopedExecutionLogs]
		PRIMARY KEY ([Execution_Id], [Scope_Sequence]),

	CONSTRAINT [FK__ScopedExecutionLogs__Executions]
		FOREIGN KEY ([Execution_Id])
		REFERENCES [Executions] ([Execution_Id])
		ON DELETE CASCADE,

	CONSTRAINT [CK__ScopedExecutionLogs__Scope_Sequence]
		CHECK ([Scope_Sequence] > 0),

	CONSTRAINT [CK__ScopedExecutionsLogs__Parent_Scope_Sequence]
		CHECK ([Parent_Scope_Sequence] IS NULL OR [Parent_Scope_Sequence] <> [Scope_Sequence])
)

CREATE TABLE [ScopedExecutionLogEntries]
(
	[Execution_Id] INT NOT NULL,
	[LogEntry_Sequence] INT NOT NULL,
	[Scope_Sequence] INT NOT NULL,
	[LogEntry_Level] INT NOT NULL,
	[LogEntry_Text] VARCHAR(MAX) NOT NULL,
	[LogEntry_Date] DATETIME NOT NULL,

	CONSTRAINT [PK__ScopedExecutionLogEntries]
		PRIMARY KEY ([Execution_Id], [LogEntry_Sequence]),

	CONSTRAINT [FK__ScopedExecutionLogEntries__ScopedExecutionLogs]
		FOREIGN KEY ([Execution_Id], [Scope_Sequence])
		REFERENCES [ScopedExecutionLogs] ([Execution_Id], [Scope_Sequence])
		ON DELETE CASCADE,

	CONSTRAINT [CK__ScopedExecutionLogEntries__LogEntry_Sequence]
		CHECK ([LogEntry_Sequence] > 0)
)
