EXEC [dbo].[__AddStoredProcInfo]
    /* StoredProc_Name         */ 'Executions_BeginExecution',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Starts a new execution.'
GO

IF OBJECT_ID('[Executions_BeginExecution]') IS NOT NULL DROP PROCEDURE [Executions_BeginExecution]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Executions_BeginExecution]
(
	@ExecutionName_Text VARCHAR(200),
	@Execution_Id INT = NULL OUT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	INSERT INTO [Executions]
	(
		[Start_Date],
		[ExecutionStatus_Code],
		[ExecutionRunState_Code],
		[ExecutionName_Text]
	)
	VALUES
	(
		GETUTCDATE(),
		'S',
		'X',
		@ExecutionName_Text
	)

	SET @Execution_Id = SCOPE_IDENTITY()

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH
END
GO

GRANT EXECUTE ON [Executions_BeginExecution] TO [InedoSecurityLabsUser_Role]
