--AH:ScriptId=5f2df172-0c91-435a-8eac-4f85c0ba0476

CREATE TABLE [Vulnerabilities]
(
	[Vulnerability_Id] INT IDENTITY(1, 1) NOT NULL,
	[UniqueId_Text] VARCHAR(20) NOT NULL,
	[Ecosystem_Name] VARCHAR(50) NOT NULL,
	[Source_Name] VARCHAR(20) NOT NULL,
	[External_Id] VARCHAR(100) NOT NULL,
	[Modified_Date] DATETIME NOT NULL,
	[Published_Date] DATETIME NULL,
	[Withdrawn_Date] DATETIME NULL,
	[Summary_Text] VARCHAR(200) NULL,
	[Details_Text] VARCHAR(MAX) NULL,
	[CVSSScore_Text] VARCHAR(50) NULL,
	[References_Text] VARCHAR(MAX) NULL,
	[CveId_Text] VARCHAR(50) NULL,
	[CweNumbers_Csv] VARCHAR(MAX) NULL,

	CONSTRAINT [PK__Vulnerabilities]
		PRIMARY KEY ([Vulnerability_Id]),

	CONSTRAINT [UQ__Vulnerabilities]
		UNIQUE ([UniqueId_Text]),

	CONSTRAINT [UQ__Vulnerabilities__External]
		UNIQUE ([Source_Name], [Ecosystem_Name], [External_Id])
)

CREATE TABLE [VulnerabilityPackages]
(
	[Vulnerability_Id] INT NOT NULL,
	[PUrl_Text] VARCHAR(200) NOT NULL,
	[AffectedVersions_Text] VARCHAR(MAX) NULL,

	CONSTRAINT [PK__VulnerabilityPackages]
		PRIMARY KEY ([Vulnerability_Id], [PUrl_Text]),

	CONSTRAINT [FK__VulnerabilityPackages__Vulnerabilities]
		FOREIGN KEY ([Vulnerability_Id])
		REFERENCES [Vulnerabilities] ([Vulnerability_Id])
		ON DELETE CASCADE
)
