EXEC [__AddStoredProcInfo]
    /* StoredProc_Name         */ 'Vulnerabilities_GetMaliciousPackages',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataSet',
    /* DataTableNames_Csv      */ 'Vulnerabilities_Extended,VulnerabilityPackages',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the list of malicious packages.'
GO

IF OBJECT_ID('[Vulnerabilities_GetMaliciousPackages]') IS NOT NULL DROP PROCEDURE [Vulnerabilities_GetMaliciousPackages]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Vulnerabilities_GetMaliciousPackages]
AS
BEGIN
    SET NOCOUNT ON

    SELECT *
    FROM [Vulnerabilities_Extended] V
    WHERE V.[External_Id] LIKE 'MAL-%'

    SELECT VP.*
	  FROM [VulnerabilityPackages] VP
	       INNER JOIN [Vulnerabilities] V
		           ON V.[Vulnerability_Id] = VP.[Vulnerability_Id]
    WHERE V.[External_Id] LIKE 'MAL-%'
END
GO

GRANT EXECUTE ON [Vulnerabilities_GetMaliciousPackages] TO [InedoSecurityLabsUser_Role]
GO