EXEC [__AddStoredProcInfo]
    /* StoredProc_Name         */ 'Vulnerabilities_GetVulnerabilitityStatistics',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'Vulnerabilites_Count,MaliciousPackages_Count,InedoAnalysis_Count',
    /* Description_Text        */ 'Gets Vulnerability Statistics.'
GO

IF OBJECT_ID('[Vulnerabilities_GetVulnerabilitityStatistics]') IS NOT NULL DROP PROCEDURE [Vulnerabilities_GetVulnerabilitityStatistics]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Vulnerabilities_GetVulnerabilitityStatistics]
(
    @Vulnerabilites_Count INT = NULL OUT,
    @MaliciousPackages_Count INT = NULL OUT,
    @InedoAnalysis_Count INT = NULL OUT
)
AS
BEGIN
    SET NOCOUNT ON
    
    SET @Vulnerabilites_Count = 
    (
        SELECT COUNT(*) 
        FROM [Vulnerabilities_Extended]
        WHERE [External_Id] NOT LIKE 'MAL-%'
    )

    SET @MaliciousPackages_Count = 
    (
            SELECT COUNT(*) 
            FROM [Vulnerabilities_Extended]
            WHERE [External_Id] LIKE 'MAL-%'
    )

    SET @InedoAnalysis_Count = 
    (
        SELECT COUNT(*) 
        FROM [Vulnerabilities_Extended]
        WHERE [HasAnalysis_Indicator] = 'Y'
    )
END
GO

GRANT EXECUTE ON [Vulnerabilities_GetVulnerabilitityStatistics] TO [InedoSecurityLabsUser_Role]
GO