EXEC [__AddStoredProcInfo]
    /* StoredProc_Name         */ 'Vulnerabilities_GetVulnerabilityAnalysis',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'VulnerabilityAnalysis',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets analysis for a vulnerability.'
GO

IF OBJECT_ID('[Vulnerabilities_GetVulnerabilityAnalysis]') IS NOT NULL DROP PROCEDURE [Vulnerabilities_GetVulnerabilityAnalysis]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Vulnerabilities_GetVulnerabilityAnalysis]
(
	@Vulnerability_Id INT
)
AS
BEGIN
    SET NOCOUNT ON

	SELECT *
	  FROM [VulnerabilityAnalysis]
	 WHERE [Vulnerability_Id] = @Vulnerability_Id

END
GO

GRANT EXECUTE ON [Vulnerabilities_GetVulnerabilityAnalysis] TO [InedoSecurityLabsUser_Role]
GO