EXEC [__AddStoredProcInfo]
    /* StoredProc_Name         */ 'Vulnerabilities_GetVulnerabilityAnalysisByVulnerabilityId',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'VulnerabilityAnalysis',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets analysis for a vulnerability.'
GO

IF OBJECT_ID('[Vulnerabilities_GetVulnerabilityAnalysisByVulnerabilityId]') IS NOT NULL DROP PROCEDURE [Vulnerabilities_GetVulnerabilityAnalysisByVulnerabilityId]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Vulnerabilities_GetVulnerabilityAnalysisByVulnerabilityId]
(
	@UniqueId_Text VARCHAR(20)
)
AS
BEGIN
    SET NOCOUNT ON

	SELECT VA.*
	  FROM [VulnerabilityAnalysis] VA
	       INNER JOIN [Vulnerabilities] V
		           ON V.[Vulnerability_Id] = VA.[Vulnerability_Id]
	 WHERE V.[UniqueId_Text] = @UniqueId_Text

END
GO

GRANT EXECUTE ON [Vulnerabilities_GetVulnerabilityAnalysisByVulnerabilityId] TO [InedoSecurityLabsUser_Role]
GO